Subject: Re: [BUG?] git-archive ignores remote .gitattributes

From: Toby Corkindale <[email-masked]>
Date: Thu, 10 Apr 2008 14:14:14 +1000

Johannes Schindelin wrote:
> Hi,
> 
> On Fri, 28 Mar 2008, Toby Corkindale wrote:
> 
>> I submit that this is a bug, or at least undesirable behaviour:
>>
>> "git-archive --remote=/some/repo" will ignore /some/repo/.gitattributes, 
>> but check /some/repo/info/attributes.
>>
>> I think the problem is in the loop that looks for .gitattributes, which 
>> seems to do so by taking the current path and iterating down through it?
> 
> The problem is that "git archive --remote" operates on the remote 
> repository as if it were bare.  Which in many cases is true.
> 
> So I'd submit that this is not the usage .gitattributes is meant for, and 
> that you should clone the thing if you want to generate archives heeding 
> the .gitattributes.

If it is not what .gitattributes is for, then what is?
The attributes docs even include specific options for archive mode 
(export-subst), which implies it is exactly meant for archive.

How about $GIT/info/attributes instead? Sadly, that isn't copied during 
clone.

I'd rather not have to clone a potentially large repository just in 
order to make an archive of one specific version. If I was going to have 
to clone it, then I could pass appropriate options to rsync or tar to 
archive instead of calling git-archive.

ie. One could create this:

#!/bin/bash
# Usage: git-archive2  <repo> <treeish>
# note - not actually a real script, don't run this.
REPO=$1
VERSION=$2
git clone $REPO
cd `basename $REPO`
git checkout $VERSION
tar cf - --exclude=.git
cd ..
rm -rf `basename $REPO`

That's silly and shouldn't be required, because git-archive --remote 
exists to perform that work. But it doesn't look at the attributes.

Is there a better way?

thanks,
Toby

-- 
Toby Corkindale
Software developer
w: www.rea-group.com
REA Group refers to realestate.com.au Ltd (ASX:REA)

Warning - This e-mail transmission may contain confidential information.
If you have received this transmission in error, please notify us
immediately on (61 3) 9897 1121 or by reply email to the sender. You
must destroy the e-mail immediately and not use, copy, distribute or
disclose the contents.